#include < amxmodx >
#include < amxmisc >
#include < army_system >
#include < hamsandwich >
#include < fun >

new a_Bonus, a_Round, g_ObjHud, g_MaxPlayers, g_SuperHE [ 33 ], g_DoubleEXP [ 33 ];
new abName [ 36 ][ 64 ], abCost [ 36 ][ 64 ], abActive [ 36 ][ 64 ], abLines;	

public plugin_init ()
{
	register_plugin ( "AS Bonus", "2.0", "OverGame" );
	
	_asb_ini_read ( "/addons/amxmodx/configs/as/ini/bonus.ini" );
	
	register_event ( "HLTV", "evet_startgame", "a", "1=0", "2=0" );
	register_event ( "TextMsg", "event_restart", "a", "2=#Game_will_restart_in","2=#Game_Commencing" );
	register_event ( "DeathMsg", "event_killing", "a" );
	RegisterHam ( Ham_TakeDamage, "player", "fwd_HamTakeDamage", 0 );
	
	register_cvar ( "as_bonus_round", "3" );
	register_cvar ( "as_bonus_time", "15.0" );
	register_cvar ( "as_bonus_block_map", "1" );
	
	register_clcmd ( "say /anew", "open_menu" );
	register_clcmd ( "say_team /anew", "open_menu" );
	
	g_ObjHud = CreateHudSyncObj ();
	g_MaxPlayers = get_maxplayers ();
	
	register_dictionary ( "as_lang.txt" );
}

public plugin_cfg ()
{
	new szCfgDir [ 64 ], szFile [ 192 ];
	get_configsdir ( szCfgDir, charsmax ( szCfgDir ) );
	format ( szFile, charsmax ( szFile ), "%s/as/cfg/bonus.cfg", szCfgDir );
	
	if ( file_exists ( szFile ) )
		server_cmd ( "exec %s", szFile );
}

public fwd_HamTakeDamage ( victim, inflicator, attacker, Float:damage )
{
	if ( is_user_connected ( attacker ) || is_user_connected ( victim ) )
		return;
		
	if ( g_SuperHE [ attacker ] )
	{
		if ( inflicator == CSW_HEGRENADE )
		{
			SetHamParamFloat ( 4, damage * 4.0 );
			g_SuperHE [ attacker ] = false;
		}
	}
}

public client_putinserver ( id )
{
	g_DoubleEXP [ id ] = false;
	g_SuperHE [ id ] = false;
}

public event_killing ()
{
	new attacker = read_data ( 1 ), victim = read_data ( 2 ), head = read_data ( 3 );
	if ( attacker == victim || !is_user_connected ( attacker ) ) return;
	if ( !g_DoubleEXP [ attacker ] ) return;
	
	if ( head )
		as_set_user_exp ( attacker, as_get_user_exp ( attacker ) + get_cvar_num ( "as_exp_head" ) );
	else
		as_set_user_exp ( attacker, as_get_user_exp ( attacker ) + get_cvar_num ( "as_exp_stand" ) );
}

public open_menu ( id )
{
	if ( get_cvar_num ( "as_bonus_block_map" ) )
	{
		if ( _asb_maps_block () )
		{
			ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_MAP" );
			return PLUGIN_HANDLED;
		}
	}
	if ( !a_Bonus )
	{
		ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_ERROR" );
		return PLUGIN_HANDLED; 
	}
	
	new szCaption [ 128 ], menu;
	format ( szCaption, charsmax ( szCaption ), "%L", LANG_SERVER, "AS_MENU_BONUS" );
	menu = menu_create ( szCaption, "func_omenu" );
	
	for ( new i; i < abLines; i++ )
	{
		new szItem [ 255 ], szTemp [ 10 ];
		
		if ( str_to_num ( abActive [ i ] ) )
			format ( szItem, charsmax ( szItem ), "\w%L \y%s \d[%d]", LANG_SERVER, "AS_MENU_BONUS_GET", abName [ i ], str_to_num ( abCost [ i ] ) );
		else
			format ( szItem, charsmax ( szItem ), "\d%L %s [%d]", LANG_SERVER, "AS_MENU_BONUS_GET", abName [ i ], str_to_num ( abCost [ i ] ) );
	
		num_to_str ( i, szTemp, charsmax ( szTemp ) );
		menu_additem ( menu, szItem, szTemp, 0 );
	}
	
	menu_setprop ( menu, MPROP_BACKNAME, "Назад" );
	menu_setprop ( menu, MPROP_NEXTNAME, "Далее" );
	menu_setprop ( menu, MPROP_EXITNAME, "Выход" );
	
	menu_display ( id, menu, 0 );
	return PLUGIN_HANDLED;
}

public func_omenu ( id, menu, item )     
{     
	if ( item == MENU_EXIT || !a_Bonus )
	{     
		menu_destroy ( menu )
		return PLUGIN_HANDLED
	}
	
	new data [ 15 ], iName [ 64 ]      
	new access, callback     
	menu_item_getinfo ( menu, item, access, data,15, iName, 64, callback )
	
	new key = str_to_num ( data )
	if ( !str_to_num ( abActive [ key ] ) )
	{
		ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_OFF" );
		
		if ( a_Bonus )
			open_menu ( id );
		
		return PLUGIN_HANDLED;
	}
	
	switch ( key )
	{
		case 0:
		{
			if ( as_get_user_bonus ( id ) >= str_to_num ( abCost [ key ] ) )
			{
				set_user_health ( id, 200 );
				set_user_armor ( id, 200 );
				as_set_user_bonus ( id, as_get_user_bonus ( id ) - str_to_num ( abCost [ key ] ) );
				
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_INFO", str_to_num ( abCost [ key ] ) );
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_BUY", abName [ key ] );
			} else {
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_NOPE", str_to_num ( abCost [ key ] ) - as_get_user_bonus ( id ) );
			}
		}
		case 1:
		{
			if ( as_get_user_bonus ( id ) >= str_to_num ( abCost [ key ] ) )
			{
				give_item ( id, "weapon_hegrenade" );
				engclient_cmd ( id, "weapon_hegrenade" );
				g_SuperHE [ id ] = true;
				
				as_set_user_bonus ( id, as_get_user_bonus ( id ) - str_to_num ( abCost [ key ] ) );
				
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_INFO", str_to_num ( abCost [ key ] ) );
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_BUY", abName [ key ] );
			} else {
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_NOPE", str_to_num ( abCost [ key ] ) - as_get_user_bonus ( id ) );
			}
		}
		case 2:
		{
			if ( as_get_user_bonus ( id ) >= str_to_num ( abCost [ key ] ) )
			{
				g_DoubleEXP [ id ] = true;
				as_set_user_bonus ( id, as_get_user_bonus ( id ) - str_to_num ( abCost [ key ] ) );
				
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_INFO", str_to_num ( abCost [ key ] ) );
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_BUY", abName [ key ] );
			} else {
				ShowMsg ( id, "%L %L", LANG_SERVER, "AS_CHAT_PREFIX", LANG_SERVER, "AS_CHAT_BONUS_NOPE", str_to_num ( abCost [ key ] ) - as_get_user_bonus ( id ) );
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

public event_restart ()
	a_Round = 0;

public evet_startgame ()
{
	a_Round++;
	if ( a_Round >= get_cvar_num ( "as_bonus_round" ) )
	{
		a_Bonus = true;
		set_task ( 0.1, "show_info" );
		
		new Float:ab_time = get_cvar_float ( "as_bonus_time" );
		set_task ( ab_time, "func_bonus_off" );
		
		for ( new id = 1; id <= g_MaxPlayers; id++ )
			g_DoubleEXP [ id ] = false;
	}
}

public func_bonus_off ()
	a_Bonus = false;

public show_info ()
{
	for ( new id = 1; id <= g_MaxPlayers; id++ )
	{
		if ( is_user_alive ( id ) && a_Bonus )
		{
			set_hudmessage ( 60, 60, 60, -1.0, 0.89, 0, 17.0, 15.0, _, _, -1 );
			
			static buffer [ 128 ], len;
			len = format ( buffer, charsmax ( buffer ), "%L", LANG_SERVER, "AS_HUD_BONUS", as_get_user_bonus ( id ) );
			len += format ( buffer [ len ], charsmax ( buffer ) - len, "^n%L", LANG_SERVER, "AS_HUD_BONUS_HELP" );
			
			ShowSyncHudMsg ( id, g_ObjHud, buffer );
		}
	}
	return PLUGIN_CONTINUE;
}

stock _asb_maps_block ()
{
	new szMapName [ 32 ], cntPos [ 3 ], status;
	get_mapname ( szMapName, charsmax ( szMapName ) );
	cntPos [ 0 ] = contain ( szMapName, "awp_" );
	cntPos [ 1 ] = contain ( szMapName, "aim_" );
	cntPos [ 2 ] = contain ( szMapName, "35hp_" );
	
	if ( cntPos [ 0 ] != -1 )
		status = true;
	
	if ( !status && cntPos [ 1 ] != - 1 )
		status = true;
		
	if ( !status && cntPos [ 2 ] != - 1 )
		status = true;
		
	return status;
}

stock _asb_ini_read ( const ini_file [] )
{
	new line, buffer [ 256 ];
	new file = fopen ( ini_file, "r" );
	
	while ( !feof ( file ) )
	{
		fgets ( file, buffer, 255 );
		trim ( buffer );
		
		if ( buffer [ 0 ] == '"' )
		{
			parse ( buffer, abName [ line ], 64, abCost [ line ], 64, abActive [ line ], 64 );
		} else {
			continue;
		}
		line++;
	}
	abLines = line;
	fclose ( file );
}

stock ShowMsg ( const id, const input [ ], any:... )
{
	new count = 1, players [ 32 ];
	static msg [ 188 ];
	vformat ( msg, 187, input, 3 );
	
	replace_all ( msg, 187, "!g", "^4" );
	replace_all ( msg, 187, "!y", "^1" );
	replace_all ( msg, 187, "!t", "^3" );
	
	if ( id ) players [ 0 ] = id; else get_players ( players, count, "ch" );
	{
		for ( new i = 0; i < count; i++ )
		{
			if ( is_user_connected ( players [ i ] ) )
			{
				message_begin ( MSG_ONE_UNRELIABLE, get_user_msgid ( "SayText" ), _, players [ i ] );
				write_byte ( players [ i ] );
				write_string ( msg );
				message_end ();
			}
		}
	}
}